
<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="$t('客户编号')" prop="number">
        <el-input v-model="queryParams.number" :placeholder="$t('请输入客户编号')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('客户名称')" prop="name">
        <el-input v-model="queryParams.name" :placeholder="$t('请输入客户名称')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('客户等级')" prop="level">
        <el-select clearable  v-model="queryParams.level" :placeholder="$t('请选择客户等级')" clearable size="small">
          <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_LEVEL)"
                     :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="dict.value"/>
        </el-select>
      </el-form-item>
      <el-form-item :label="$t('联系方式')">
        <el-input :placeholder="$t('请输入联系方式')" v-model="queryParams.defaultContactPhone"></el-input>
      </el-form-item>
      <el-form-item :label="$t('客户类别')" prop="level">
        <dict-selector :type="DICT_TYPE.CUSTOMER_TYPE"  v-model="queryParams.type"></dict-selector>
      </el-form-item>
      <el-form-item :label="$t('客户经理')" prop="customerService">
        <el-select clearable  v-model="queryParams.customerService" :placeholder="$t('请选择客户经理')" clearable size="small">
          <el-option v-for="dict in customerServiceList"
                     :key="dict.id" :label="dict.nickname" :value="dict.id"/>
        </el-select>
      </el-form-item>
      <el-form-item :label="$t('客户来源')" prop="source">
        <el-select clearable  v-model="queryParams.source" :placeholder="$t('请选择客户来源')" clearable size="small">
          <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_SOURCE)"
                     :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="dict.value"/>
        </el-select>
      </el-form-item>
      <el-form-item :label="$t('国家')" prop="source">
        <el-select clearable  v-model="queryParams.country" :placeholder="$t('请选择国家')">
          <el-option v-for="dict in countryList"
                     :key="dict.id" :label="isChinese ? dict.nameZh : dict.nameEn" :value="parseInt(dict.id)" />
        </el-select>
      </el-form-item>
      <el-form-item :label="$t('客户状态')" prop="status">
        <el-select clearable  v-model="queryParams.status" :placeholder="$t('请选择客户状态')" clearable size="small">
          <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_STATUS)"
                     :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="dict.value"/>
        </el-select>
      </el-form-item>
      <el-form-item :label="$t('创建时间')">
        <el-date-picker clearable  v-model="dateRangeCreateTime" style="width: 240px" value-format="yyyy-MM-dd HH:mm:ss"
                        type="datetimerange"  range-separator="-" :start-placeholder="$t('开始日期')" :end-placeholder="$t('结束日期')" />
      </el-form-item>
      <el-form-item :label="$t('信用等级')" prop="department">
        <el-select clearable  v-model="queryParams.creditLevel" >
          <el-option  v-for="(item,index) in creditList" :label="isChinese ? item.nameZh : item.nameEn" :key="index" :value="item.id" ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item  :label="$t('市场获客')" prop="department">
        <dict-selector clearable  :type="DICT_TYPE.ECW_CUSTOMER_RESOURCE_TYPE" v-model="queryParams.marketType" formatter="number"></dict-selector>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">{{$t('搜索')}}</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">{{$t('重置')}}</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['ecw:customer:distribution-create']">{{$t('新增')}}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['ecw:customer:distribution-export']">{{$t('导出')}}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-col :span="1.5" >
          <el-button :disabled="selectCustomerList.length === 0"  type="primary" size="mini" @click="batchTransferShow = true;"
                     v-hasPermi="['ecw:customer:distribution-transfer']">{{$t('批量移交')}}</el-button>
        </el-col>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table ref="multipleTable" v-loading="loading" :data="list" @selection-change="handleSelectionChange">
      <el-table-column
        type="selection"
        width="55">
      </el-table-column>
      <el-table-column :label="$t('客户编号')" align="center" prop="number" >
        <template v-slot="{row}">
          <router-link :to="'/customer/query/' + row.id">
            {{row.number}}
          </router-link>
        </template>
      </el-table-column>
      <el-table-column :label="$t('客户名称')" align="center" prop="name" >
        <template v-slot="{row}">
          {{$l(row, 'name')}}
        </template>
      </el-table-column>
      <el-table-column :label="$t('客户等级')" align="center" prop="vipLevelNameZh">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.CUSTOMER_LEVEL" :value="scope.row.level" />
        </template>
      </el-table-column>
      <el-table-column :label="$t('信用等级')" :prop=" isChinese ? 'creditLevelNameZh' : 'creditLevelNameEn' "></el-table-column>
      <el-table-column :label="$t('客户状态')" align="center" prop="status">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.CUSTOMER_STATUS" :value="scope.row.status" />
        </template>
      </el-table-column>
      <el-table-column :label="$t('主联系人')" prop="defaultContactName"></el-table-column>
      <el-table-column :label="$t('主联系方式')" prop="defaultContactPhone">
        <template v-slot="{row}">
          +{{row.defaultContactPhone}}
        </template>
      </el-table-column>
      <el-table-column :label="$t('创建时间')" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column :label="$t('客户经理')" align="center" prop="customerServiceName">
      </el-table-column>
      <el-table-column :label="$t('国家')" align="center" prop="country" :formatter="countryFormatter"></el-table-column>
      <el-table-column :label="$t('操作')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['ecw:customer:distribution-update']">{{$t('编辑')}}</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['ecw:customer:distribution-delete']">{{$t('删除')}}</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="distribution(scope.row)"
                     v-hasPermi="['ecw:customer:distribution-customer-service']">{{$t('分配客服')}}</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!--   移交 -->
    <el-dialog
      center
      :title="$t('客服')"
      :visible.sync="transferShow"
      width="30%">
      <div style="width: 100%;min-height: 200px;text-align: center;">
<!--        <el-radio-group v-model="service">-->
<!--          <el-radio style="margin: 5px;" v-for="(item,index) in customerServiceList" :key="index" :label="item.id">{{item.nickname}}</el-radio>-->
<!--        </el-radio-group>-->
        <el-select filterable v-model="service">
          <el-option v-for="(item,index) in customerServiceList" :key="index" :label="item.nickname" :value="item.id"></el-option>
        </el-select>
      </div>
      <span slot="footer" class="dialog-footer">
    <el-button @click="transferShow = false">{{$t('取 消')}}</el-button>
    <el-button type="primary" @click="transferFn">{{$t('确 定')}}</el-button>
  </span>
    </el-dialog>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>
    <transfer-customer :show.sync="batchTransferShow" :customer-ids.sync="selectCustomerList"></transfer-customer>
  </div>
</template>

<script>
import {
  createCustomer, updateCustomer, deleteCustomer, getCustomer, handOverCustomer,
  exportCustomerExcel, getCustomerToBeAssigned, waitDistributionExportExcel
} from "@/api/ecw/customer";
import { getDictDatas, DICT_TYPE } from '@/utils/dict';
import upload from '@/components/ImageUpload'
import {listServiceUser} from "@/api/system/user";
import {getCountryListAll} from "@/api/ecw/country";
import {getCreditPage} from "@/api/customer/credit";
import transferCustomer from "@/views/ecw/customer/transferCustomer";
import Template from "@/views/cms/template/index.vue";
export default {
  name: "EcwCustomertobeassignedIndex",
  activated() {
     this.getList()
    },
  components: {
    Template,
    upload,
    transferCustomer
  },
  data() {
    return {
      batchTransferShow:false,
      getDictDatas,
      DICT_TYPE,
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 客户列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeCreateTime: [],
      customerServiceList:[],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        number: null,
        name: null,
        level: null,
        source: null,
        customerService: null,
        status: null,
        department: null,
        creditLevel:null,
        country:null,
        marketType:null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name: [{ required: true, message: this.$t('客户名称不能为空'), trigger: "blur" }],
        country: [{ required: true, message: this.$t('国家不能为空'), trigger: "blur" }],
        level: [{ required: true, message: this.$t('客户等级不能为空'), trigger: "blur" }],
        type: [{ required: true, message: this.$t('客户类别不能为空'), trigger: "blur" }],
        // createTime: [{ required: true, message: this.$t("创建时间不能为空"), trigger: "blur" }],
        source: [{ required: true, message: this.$t('客户来源不能为空'), trigger: "blur" }],
        customerService: [{ required: true, message: this.$t('客户经理不能为空'), trigger: "blur" }],
        status: [{ required: true, message: this.$t('客户状态不能为空'), trigger: "blur" }],
        founder: [{ required: true, message: this.$t('创建人不能为空'), trigger: "blur" }],
      },
      // 网点
      nodeList: [],
      showLine: false,
      service:undefined,//客服
      transferData:undefined,//移交数据
      transferShow:false,
      creditList:[],
      selectCustomerList:[],
      countryList:[]
    };
  },
  created() {
    getCountryListAll().then(r => {
      console.log(r,'国家')
      this.countryList = r.data
    })
    getCreditPage({page:1,rows:999}).then(r => {
      this.creditList = r.data.list
    })
    this.getList();
    listServiceUser().then(r=>{
      console.log(r,'客服');
      this.customerServiceList = r.data;
    })
    // getNodeList().then(r => {
    //   this.nodeList = r.data
    // })
  },
  methods: {
    countryFormatter(row, column, cellValue) {
      const country = this.countryList.find((e) => e.id === cellValue)
      return this.isChinese ? country?.nameZh : country?.nameEn
    },
    handleSelectionChange(val){
      this.selectCustomerList = val.map(i => i.id);
    },
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime', false);
      // 执行查询
      getCustomerToBeAssigned(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        number: undefined,
        name: undefined,
        level: undefined,
        country: undefined,
        type: undefined,
        agentId: undefined,
        company: undefined,
        address: undefined,
        productType: undefined,
        productId: undefined,
        pickupPoint: undefined,
        memberId: undefined,
        birthday: undefined,
        balance: undefined,
        source: undefined,
        picture: undefined,
        customerService: undefined,
        customerContacts: [],
        customerLines: [],
        promoter: undefined,
        status: undefined,
        founder: undefined,
        department: undefined,
        invoiceTitle: undefined,
        licenseNumber: undefined,
        bank: undefined,
        bankNumber: undefined,
        project: undefined,
        billingAddress: undefined,
        billingTell: undefined,
        taxRate: undefined,
        remarks: undefined,
        arrivalConfirm: undefined,
        weightUnit: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.queryParams = {
        pageNo: 1,
        pageSize: 10,
        number: null,
        name: null,
        level: null,
        source: null,
        customerService: null,
        status: null,
        department: null,
        creditLevel:null,
        country:null,
      }
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.$router.push('/customer/add-edit/0')
      // this.reset();
      // this.open = true;
      // this.title = this.$t("添加客户");
    },
    /** 查看按钮操作 */
    handleView(row) {
      this.$router.push('/customer/query/' + row.id)
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.$router.push('/customer/edit-distribution/' + row.id)
      // this.reset();
      // const id = row.id;
      // getCustomer(id).then(response => {
      //   this.form = { ...this.form, ...response.data };
      //   this.open = true;
      //   this.title = this.$t("修改客户");
      // });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          // return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateCustomer(this.form).then(response => {
            this.$modal.msgSuccess(this.$t('修改成功'));
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createCustomer(this.form).then(response => {
          this.$modal.msgSuccess(this.$t('新增成功'));
          this.open = false;
          this.getList();
        });
      });
    },
    /** 移交按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm(this.$t('是否确认删除客户编号为"') + row.number + this.$t('"的数据项?')).then(function() {
        return deleteCustomer(id);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess(this.$t('删除成功'));
      }).catch(() => {});
    },
    //分配客服
    distribution(row){
      this.service = row.customerService;
      this.transferData = row;
      this.transferShow =true;
    },
    transferFn(){
      if(!this.service){
        return this.$message.warning(this.$t('请选择客户经理！'));
      }
      handOverCustomer({
        customerServiceId:this.service,
        customerIdList :[this.transferData.id]
      }).then(r=>{
        if(r.code === 0){
          this.transferShow = false;
          this.service = '';
          this.getList();
          this.$message.success(this.$t('移交成功！'));
        }
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm(this.$t('是否确认导出待分配客户数据项?')).then(() => {
        this.exportLoading = true;
        return waitDistributionExportExcel(params);
      }).then(response => {
        this.$download.excel(response,  `${this.$t('待分配客户')}.xls`);
        this.exportLoading = false;
      }).catch(() => {});
    },
  },
  watch:{
    selectCustomerList(val){
      if(val.length === 0){
        this.getList()
        this.$refs.multipleTable.clearSelection();
      }
    },
  },
  computed:{
    isChinese(){
      return this.$i18n.locale === 'zh_CN'
    },
  }
};
</script>
